image: busybox:latest

stages:
  - build
  - test
  - deploy
  - stop

variables:
  IMAGE_TAG: $CI_COMMIT_BRANCH-$CI_COMMIT_SHORT_SHA

deploy to preprod:
  stage: deploy
  variables:
    TARGET_ENV: preprod
    MyLogin: MyLoginPreprod
  script:
    - echo "Do your deploy here to ${TARGET_ENV}"
    - echo "Stage preprod MyLogin= $MyLogin"
    - echo "Stage preprod MyPassword= $MyPassword"
  only:
    - main
  environment:
    name: preprod
    on_stop: stop to preprod
    auto_stop_in: 1 day

stop to preprod:
  stage: stop
  variables:
    TARGET_ENV: preprod
    MyLogin: MyLoginPreprod
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - main
  when: manual
  environment:
    name: preprod
    action: stop

deploy to production:
  stage: deploy
  variables:
    TARGET_ENV: production
    MyLogin: MyLoginProduction
  script:
    - echo "Do your deploy here to ${TARGET_ENV}"
    - echo "Stage production MyLogin= $MyLogin"
    - echo "Stage preprod MyPassword= $MyPassword"
  only:
    - main
  when: manual
  environment:
    name: production
    on_stop: stop to production

stop to production:
  stage: stop
  variables:
    TARGET_ENV: production
    MyLogin: MyLoginProduction
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - main
  when: manual
  environment:
    name: production
    action: stop

docker build:
  image: docker:latest
  stage: build
  services: 
    - docker:dind
  script:
    - docker login -u $GITLAB_CI_USER -p $GITLAB_CI_PASSWORD $CI_REGISTRY
    - echo $CI_REGISTRY_USER $CI_REGISTRY_PASSWORD $CI_REGISTRY  $CI_REGISTRY_IMAGE:$IMAGE_TAG
    - docker build -t $CI_REGISTRY_IMAGE:$IMAGE_TAG .
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG

test1:
  image: docker:latest
  stage: test
  services: 
    - docker:dind
  script:
    - docker login -u $GITLAB_CI_USER -p $GITLAB_CI_PASSWORD $CI_REGISTRY
    - docker run $CI_REGISTRY_IMAGE:$IMAGE_TAG echo 'hello from docker test'
